#include "stdafx.h"

using namespace std;

vector::vector(int n)
{	this->n=n;
	p = new double[n];
	cout << "vector::ctor " << n << " elements" << endl;
}

vector::~vector()
{	delete p;
	cout << "vector " << n << " deleted" << endl;
}

double vector::get(int i)
{	if (i<0 || i>=n) throw "vector::get - index out of bounds";
	return p[i];
}

void vector::set(int i, double x)
{	if (i<0 || i>=n) throw "vector::set - index out of bounds";
	p[i]=x;
}

double & vector::operator[](int i)
{	if (i<0 || i>=n) throw "vector::operator[] - index out of bounds";
	return p[i];
}

bool vector::operator ==( vector &x)
{
	if  (n!=x.size()) throw "Erorr: vectors have diferent dimensions";
	for (int i=0; i<n; i++) 
		if (p[i]!=x[i]) return false;
	return true;
}

void vector::operator=(vector &x)
{
	if  (n!=x.size()) throw "Erorr: vectors have diferent dimensions";
	for (int i=0; i<n; i++) p[i]=x[i];
}